package JawinTest;

import java.math.BigInteger;
import java.util.Date;

import com.develop.jawin.COMException;
import com.develop.jawin.DispatchPtr;
import com.develop.jawin.ObjectRef;
import com.develop.jawin.IntegerRef;
import com.develop.jawin.BigIntegerRef;
import com.develop.jawin.DateRef;
import com.develop.jawin.StringRef;
import com.develop.jawin.constants.DispatchConstants;

public class Test {
    public static void main(String[] args) {
        String[] str = null;
        ObjectRef objRef = null;
        ObjectRef objNew = null;
        _sJawinTest oResult = null;
        BigIntegerRef currencyRef = null;
        try{
            _sJawinTest oJawinTest = new _sJawinTest("JawinTest.sJawinTest");
            oJawinTest.addEventListener(__sJawinTest.class, new sJawinTestListener());
            oJawinTest.ShowMsgBox();
            oJawinTest.RaiseMyEvent();
            objRef = new ObjectRef(new String[]{});
            oJawinTest.ReturnStringArray(objRef);
            if(objRef.getRef() instanceof String[]) {
                String[] stra = (String[])objRef.getRef();
                System.out.println("Array from VB:");
                for(int i = 0; i < stra.length; i++)
                    System.out.println("("+i+")"+stra[i]);
            }
            Date oJavaDate = new Date();
            System.out.println(oJavaDate.toString());
            oJavaDate.setDate(30);
            oJavaDate.setMonth(3);
            oJavaDate.setYear(75);
            oJavaDate.setHours(4);
            oJavaDate.setMinutes(37);
            oJavaDate.setSeconds(12);
            System.out.println(oJavaDate.toString());
            oJawinTest.TestsOptionalVariants(DispatchConstants.vtMissing, oJavaDate);
            objNew = new ObjectRef();
            oJawinTest.GetObject(objNew);
            ObjectRef oArrRef = new ObjectRef(); 
            oJawinTest.GetVarintArray(oArrRef);
            
            Object[] oArrResult = (Object[])oArrRef.getRef();
            System.out.println("\nVariant Array ByRef From Basic:");
            for(int i = 1; i < oArrResult.length; i++)
                System.out.println("var(" + i + ")=" + oArrResult[i].toString() + ";");
            System.out.println();
            oResult = new _sJawinTest((DispatchPtr)objNew.getRef());
            oResult.ShowMsgBox();
            _sJawinTest oJawinTest2 = new _sJawinTest(JawinTest.sJawinTest.clsID);
            oJawinTest2.CallInside(new ObjectRef(oJawinTest2));
            // Currency Value: 1000000.0000
            oJawinTest.PassCurrency(new BigInteger("10000000000"));
            currencyRef = new BigIntegerRef(new BigInteger("0"));
            oJawinTest.GetCurrency(currencyRef);
            System.out.println("Currency result from VB:" + ((BigInteger)currencyRef.getRef()).divide(new BigInteger("10000")).toString());
        }
        catch(COMException e){
            System.out.println("oJawinTest failure");
            e.printStackTrace();
            System.out.println(e.toString());
        }
        System.exit(0);
    }
}
class sJawinTestListener implements __sJawinTest {
    public void Start(Object srcObj, StringRef  sStartParam) throws COMException {
        try{
            System.out.println("Start event fired: Start(" + sStartParam + ")");
            _sJawinTest oJawinTest2 = new _sJawinTest("JawinTest.sJawinTest");
            int i = 0;
            int iParam = 0;
            IntegerRef oParam = new IntegerRef(iParam);
            int iParam2 = 0;
            IntegerRef oParam2 = new IntegerRef(iParam2);
            StringRef strObject = new StringRef(new String());
            _sJawinTest source = (_sJawinTest)srcObj;
            i = source.LongReturn(oParam, oParam2, strObject, oJawinTest2);
            System.out.print(i + " == LongReturn(" + oParam.getRef().toString() + ", ");
            System.out.println(oParam2.getRef().toString() + ", \"" + strObject.getRef().toString() + "\", oJawinTest2)");
        }
        catch(Throwable e){
            System.out.println("oJawinTest failure");
            e.printStackTrace();
            System.out.println(e.toString());
        }
    }
}